﻿@page "/tasks"
@page "/tasks/archive"
@using Microsoft.Extensions.Localization
@using Microsoft.EntityFrameworkCore
@using Microsoft.AspNetCore.Components
@using System.Threading
@using System.Diagnostics.CodeAnalysis
@using OWebApplication.Operators

@inject AuthenticationStateProvider _authenticationStateProvider
@inject IDbContextFactory<OvertestDatabaseContext> _dbContextFactory
@inject IStringLocalizer<TasksArchive> _localizer
@inject NavigationManager _navigationManager
@inject UserAccessControlOperator _userAccessControlOperator
@inject UserManager<User> _userManager

@inject ISnackbar _snackbar

<MudContainer MaxWidth="MaxWidth.Large" Class="my-3">
    <MudToolBar Class="px-0" Style="height: auto;">
        <MudText Typo="Typo.h5" Style="font-weight: bold; line-height: 1;">@_localizer["Архів завдань"]</MudText>
        <MudSpacer />
        @if (_currentUserHasAdminPermissions)
        {
            <MudIconButton OnClick="@(() => _navigationManager.NavigateTo("/admin/tasks/import"))"
                           Icon="@Icons.Material.Outlined.Add"></MudIconButton>
            <MudIconButton OnClick="@(() => _snackbar.Add(_localizer["Coming soon!"], Severity.Warning))"
                           Icon="@Icons.Material.Outlined.ManageSearch"></MudIconButton>
        }
    </MudToolBar>
    <MudPaper Outlined="true" Class="pa-3 mt-1">
        <MudGrid>
            <MudItem xs="6" md="5">
                <MudTextField Label="@_localizer["Пошук по назві"]" Variant="Variant.Outlined"
                              Margin="Margin.Dense" Clearable="true" @bind-Value="_searchByTaskTitle"></MudTextField>
            </MudItem>
            
            <MudItem xs="6" md="5">
                <MudSelect Label="@_localizer["Категорія"]" Variant="Variant.Outlined"
                           Margin="Margin.Dense" Clearable="true" @bind-Value="_searchByTaskCategory" T="string">
                    @foreach (var categoryName in _categoriesList)
                    {
                        <MudSelectItem T="string" Value="@categoryName">@categoryName</MudSelectItem>
                    }
                </MudSelect>
            </MudItem>
            
            <MudItem xs="12" md="2">
                <MudButton Variant="Variant.Filled" Color="Color.Primary" Size="Size.Large" DisableElevation="true" FullWidth="true"
                           StartIcon="@Icons.Material.Filled.Search" Style="height: 45px;" OnClick="ExecuteSearchRequestAsync">@_localizer["Пошук"]</MudButton>
            </MudItem>
        </MudGrid>
    </MudPaper>
</MudContainer>

@* Search results container *@
<MudContainer MaxWidth="MaxWidth.Large" class="mb-3">
    @if (_searchResultsOnCurrentPage == null)
    {
        <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="100%" Height="300px" />
    }
    else if (_searchResultsOnCurrentPage.Count <= 0)
    {
        <MudAlert Severity="Severity.Info" Elevation="0">
            @_localizer["За вашим запитом, на жаль, нічого не знайдено. Спробуйте змінити параметри пошуку, або почніть пошук з чистого аркуша."]
        </MudAlert>
    }
    else
    {
        <MudTable Items="@_searchResultsOnCurrentPage" Hover="true" Breakpoint="Breakpoint.None" Outlined="true" Elevation="0" Class="mb-3">
            <HeaderContent>
                <MudTh Style="white-space: nowrap;">@_localizer["Назва завдання"]</MudTh>
                <MudTh Style="white-space: nowrap;">@_localizer["Назва категорії"]</MudTh>
                <MudTh Style="white-space: nowrap; text-align: center;">@_localizer["Складність"]</MudTh>
            </HeaderContent>
            <RowTemplate>
                <MudTd Style="white-space: nowrap;">
                    <MudLink Style="white-space: nowrap;" Href="@($"/tasks/view/{context.Id}")">@context.Title</MudLink>
                </MudTd>
                <MudTd Style="white-space: nowrap;">
                    <MudLink Style="white-space: nowrap;" Href="javascript://void(0)">@context.CategoryName</MudLink>
                </MudTd>
                <MudTd Style="font-weight: bold; text-align: center;">@context.Difficulty</MudTd>
            </RowTemplate>
            <PagerContent>
                <MudPagination SelectedChanged="OnPaginationSelectedPageChangedAsync" Count="@_searchResultsTotalPages" Class="pa-4"/>
            </PagerContent>
        </MudTable>
    }
</MudContainer>
@* /Search results container *@

@code {
    private SemaphoreSlim _semaphore;
    private List<string> _categoriesList;

    private string _searchByTaskTitle;
    private string _searchByTaskCategory;
    private const int SearchResultsPerPage = 30;
    private int _searchResultsTotalCount;
    private int _searchResultsTotalPages;
    private int _searchResultsCurrentPage;
    private List<TasksArchiveListItem> _searchResultsOnCurrentPage;

    private Guid _currentUserId;
    private bool _currentUserHasAdminPermissions;

    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();

        _categoriesList = new List<string>();
        _searchByTaskTitle = null;
        _searchByTaskCategory = null;
        
        _searchResultsTotalCount = 1;
        _searchResultsCurrentPage = 1;
        _searchResultsOnCurrentPage = null;
        
        _semaphore = new SemaphoreSlim(1, 1);

        var authenticationState = await _authenticationStateProvider.GetAuthenticationStateAsync();
        _currentUserId = new Guid(_userManager.GetUserId(authenticationState.User));

        await using var databaseContext = _dbContextFactory.CreateDbContext();
        _currentUserHasAdminPermissions = await _userAccessControlOperator.HasUserTypeAsync(databaseContext,
            _currentUserId, UserType.SuperUser);
    }

    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        await base.OnAfterRenderAsync(firstRender);

        if (!firstRender)
            return;

        await FetchTaskCategoriesListAsync();
        StateHasChanged();

        await ExecuteSearchRequestAsync();
        StateHasChanged();
    }

    private async Task FetchTaskCategoriesListAsync()
    {
        await _semaphore.WaitAsync();
        try
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();

            var categoriesList = await databaseContext.ProgrammingTasks.AsNoTracking()
                .OrderBy(order => order.Category)
                .Select(s => s.Category)
                .Distinct().ToListAsync();

            categoriesList.Remove(string.Empty);
            categoriesList.Remove(null);

            _categoriesList = categoriesList;
        }
        finally
        {
            _semaphore.Release();
        }
    }

    private async Task ExecuteSearchRequestAsync()
    {
        if (_semaphore.CurrentCount < 1)
            return;
        await _semaphore.WaitAsync();

        if (_searchResultsOnCurrentPage is not null)
        {
            _searchResultsOnCurrentPage = null;
            StateHasChanged();
        }
        
        try
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();

            if (string.IsNullOrWhiteSpace(_searchByTaskTitle))
                _searchByTaskTitle = null;

            if (string.IsNullOrWhiteSpace(_searchByTaskCategory))
                _searchByTaskCategory = null;

            var searchRequest = databaseContext.ProgrammingTasks.AsNoTracking()
                .Where(t => t.Enabled == true)
                .Where(t => _searchByTaskTitle == null || EF.Functions.Like(t.Title, $"%{_searchByTaskTitle}%"))
                .Where(t => _searchByTaskCategory == null || EF.Functions.Like(t.Category, $"%{_searchByTaskCategory}%"))
                .OrderBy(order => order.Difficulty)
                .ThenBy(order => order.Category)
                .ThenBy(order => order.Title)
                .Select(s => new TasksArchiveListItem
                {
                    Id = s.Id,
                    Title = s.Title,
                    CategoryName = s.Category,
                    Difficulty = s.Difficulty
                });

            _searchResultsTotalCount = await searchRequest.CountAsync();

            if (_searchResultsTotalCount <= 0)
            {
                _searchResultsOnCurrentPage = new List<TasksArchiveListItem>();
                _searchResultsTotalPages = 1;
                _searchResultsCurrentPage = 1;
            }
            else
            {
                _searchResultsTotalPages = (int)Math.Ceiling(_searchResultsTotalCount / (double)SearchResultsPerPage);
                var previousItemsCount = (_searchResultsCurrentPage - 1) * SearchResultsPerPage;

                if (_searchResultsCurrentPage > _searchResultsTotalPages)
                    _searchResultsCurrentPage = 1;

                _searchResultsOnCurrentPage = await searchRequest
                    .Skip(previousItemsCount)
                    .Take(SearchResultsPerPage)
                    .ToListAsync();
            }
        }
        finally { _semaphore.Release(); }
    }

    private async Task OnPaginationSelectedPageChangedAsync(int currentPage)
    {
        if (_searchResultsCurrentPage == currentPage)
            return;

        _searchResultsCurrentPage = currentPage;
        await ExecuteSearchRequestAsync();
    }
    
    [SuppressMessage("ReSharper", "PropertyCanBeMadeInitOnly.Local")]
    private class TasksArchiveListItem
    {
        //public TasksArchiveListItem() => CurrentUserResult = TaskSolution.SolutionAdjudgementType.NoAdjudgement;
        
        public Guid Id { get; set; }
        public string Title { get; set; }
        public string CategoryName { get; set; }
        public int Difficulty { get; set; }
        
        // TODO: Show info about user's submissions
        // public TaskSolution.SolutionAdjudgementType CurrentUserResult { get; set; }
    }
}